#encoding=utf8
import torch
import string,os,random
from PIL import Image
import numpy as np
from tqdm import tqdm
from torch.utils import data
from torch.autograd import Variable
import torchvision
from torchvision.datasets import DatasetFolder
from efficientnet_pytorch import EfficientNet
from torchvision import transforms
from albumentations.pytorch import ToTensor
from albumentations import (
    HorizontalFlip, IAAPerspective, ShiftScaleRotate, CLAHE, RandomRotate90,
    Transpose, ShiftScaleRotate, Blur, OpticalDistortion, GridDistortion, HueSaturationValue,
    IAAAdditiveGaussianNoise, GaussNoise, MotionBlur, MedianBlur, RandomBrightnessContrast, IAAPiecewiseAffine,
    IAASharpen, IAAEmboss, Flip, OneOf, Compose, Resize
)
chinese = ['蜣', '科', '斟', '邂', '娈', '樨', '诚', '钥', '猛', '笠', '圜', '泥', '衾', '倔', '撩', '汇', '崧', '汲', '绉', '拓', '眠', '餪', '瀚', '嫉', '捻', '酯', '菌', '蟒', '骄', '唇', '饺', '啐', '王', '昌', '剑', '赢', '筐', '儋', '疝', '捱', '泛', '棕', '焅', '傩', '埒', '湮', '霜', '先', '可', '思', '展', '丸', '共', '泯', '翻', '侯', '安', '磙', '癍', '韦', '缎', '后', '蹑', '凫', '咖', '照', '纷', '趑', '誓', '溥', '暨', '沆', '蔻', '盒', '蘸', '宋', '鄒', '以', '羝', '旬', '蛳', '查', '脑', '螣', '蹊', '褚', '城', '醐', '艴', '铪', '怎', '邪', '暗', '桑', '枞', '舖', '理', '驸', '叹', '噙', '蘼', '扁', '苞', '傣', '笋', '雕', '孬', '吗', '企', '翅', '要', '鳌', '规', '樽', '刀', '涑', '寅', '亁', '伸', '坦', '伐', '仓', '架', '发', '嘱', '叛', '尕', '吏', '萌', '囵', '颗', '鲳', '磨', '族', '短', '谩', '惴', '吽', '綮', '夼', '虍', '唠', '跻', '极', '缘', '蒂', '洁', '奕', '鞍', '逍', '苒', '倡', '瞩', '选', '弥', '删', '逊', '踹', '搁', '赖', '鼹', '骥', '聆', '昔', '寐', '圣', '曦', '吸', '锗', '痫', '臾', '担', '兄', '秦', '乍', '募', '炙', '抵', '膺', '灵', '绾', '虬', '漉', '厌', '犹', '薇', '薛', '甫', '赐', '莲', '蜞', '茁', '斛', '嗜', '枉', '怪', '鳏', '姐', '逆', '繁', '级', '卢', '倪', '扼', '研', '诞', '恳', '涉', '靓', '松', '券', '音', '茎', '蹄', '妹', '六', '馃', '肢', '锰', '谷', '琉', '帜', '力', '堑', '谎', '鄙', '谮', '履', '骣', '邻', '钦', '攸', '碰', '骇', '调', '才', '畅', '亊', '贞', '臃', '挎', '遨', '拄', '辗', '耀', '行', '蚀', '鞘', '仙', '扈', '缈', '乩', '邋', '高', '比', '槐', '例', '夹', '脸', '惦', '潇', '帝', '枥', '魑', '紫', '锱', '颂', '鹂', '凛', '鼬', '瘪', '蹰', '阍', '粱', '桴', '槽', '哨', '损', '芊', '则', '醭', '户', '萁', '蟾', '祈', '悉', '雨', '酸', '拊', '瞧', '喽', '对', '掰', '熊', '梨', '迹', '峦', '座', '佗', '馏', '稞', '何', '葛', '炒', '饹', '菤', '帛', '仇', '鸈', '孟', '乐', '鲸', '荽', '坎', '愧', '绸', '诟', '盂', '衿', '兔', '铁', '榆', '篮', '荪', '独', '孓', '寂', '洲', '烟', '倚', '广', '搂', '童', '俐', '饮', '板', '弦', '杯', '彝', '讼', '窕', '标', '蟹', '蒜', '铤', '犬', '绳', '计', '郂', '答', '颼', '殒', '睹', '榱', '犊', '同', '榟', '漪', '限', '若', '虱', '棺', '鲈', '殓', '烀', '铲', '溉', '庥', '幢', '炸', '柴', '尬', '赣', '兴', '囊', '祀', '冯', '郝', '典', '急', '养', '刺', '雠', '壬', '仑', '莽', '稀', '钞', '忧', '恸', '莜', '打', '镪', '曈', '势', '潴', '嗪', '恃', '婧', '楞', '软', '篇', '聒', '堤', '举', '桀', '盅', '鹄', '琶', '回', '谣', '冢', '柁', '耽', '匀', '咱', '汐', '筝', '方', '琎', '睁', '陂', '沂', '戊', '嚷', '动', '粒', '嗟', '薯', '蚝', '目', '呑', '椽', '攵', '槑', '炔', '粥', '睬', '戈', '涕', '据', '街', '律', '杏', '绍', '昧', '龌', '獗', '腐', '跌', '愆', '梵', '蜻', '荚', '翳', '赡', '征', '腴', '诹', '滤', '硒', '阚', '鞑', '言', '宝', '命', '彰', '戴', '际', '泾', '椭', '汆', '拘', '焉', '胁', '凄', '壤', '弟', '磁', '嫁', '朽', '幼', '带', '拇', '肉', '息', '檬', '冉', '等', '瞭', '武', '鳝', '增', '哐', '落', '秕', '跃', '旨', '戌', '还', '亵', '辘', '炯', '猬', '榭', '奘', '嘶', '系', '心', '年', '鹿', '废', '呆', '沥', '拐', '杭', '煦', '专', '慕', '干', '褐', '捌', '婪', '庶', '跄', '某', '奖', '自', '腿', '晋', '淙', '亚', '疚', '淘', '酾', '澈', '鉰', '埏', '稿', '皈', '戟', '采', '沛', '准', '鳇', '蛏', '魄', '饪', '品', '挽', '棋', '霏', '小', '蜚', '侗', '诩', '稠', '拯', '瞑', '妆', '恙', '固', '衅', '塾', '葹', '详', '编', '酝', '璃', '尼', '掴', '姝', '区', '邝', '诃', '笼', '拉', '鲮', '垂', '忘', '颍', '督', '壕', '焦', '泗', '续', '欠', '协', '攀', '爬', '嘁', '疤', '狩', '敕', '嬉', '宛', '棱', '魔', '钒', '沫', '竞', '抱', '邈', '鳍', '萋', '髋', '圄', '待', '璀', '谔', '婢', '昨', '糥', '扒', '颅', '身', '稣', '捩', '匕', '畏', '踟', '讥', '汰', '粘', '阴', '噗', '狗', '盼', '洞', '腰', '筮', '面', '鹁', '澹', '靳', '不', '亥', '讧', '僻', '搡', '牡', '谇', '门', '悼', '骆', '煮', '跤', '霆', '驶', '轶', '罂', '课', '觚', '列', '母', '与', '石', '饰', '舅', '歧', '拨', '焗', '羌', '蜷', '檗', '巧', '砚', '积', '瘙', '鸵', '脉', '鲷', '宙', '煜', '坳', '沙', '裟', '悟', '颖', '蔯', '浚', '氦', '苏', '姣', '珀', '流', '蚜', '觅', '竴', '幻', '走', '践', '牛', '护', '栀', '虎', '功', '眷', '砂', '逞', '铝', '婥', '寳', '抍', '囤', '叠', '黍', '釉', '愕', '雷', '途', '砻', '褓', '脓', '森', '骊', '袷', '舞', '岔', '肆', '妯', '璋', '陨', '脊', '泓', '辰', '台', '敏', '意', '镩', '臭', '瞥', '醅', '袖', '滦', '俗', '麒', '危', '做', '鲰', '顾', '孪', '汽', '诿', '辅', '桶', '逐', '莫', '董', '壁', '踢', '箪', '亿', '叮', '馘', '梆', '宣', '镍', '房', '溘', '刈', '趋', '甘', '撑', '俑', '甸', '供', '蔷', '皆', '辆', '风', '辩', '晷', '酢', '躁', '似', '彪', '酰', '骈', '疾', '韵', '口', '侃', '魂', '乱', '巩', '沭', '喘', '悃', '窑', '熳', '辔', '亩', '孑', '庭', '黢', '递', '咣', '纩', '舍', '睚', '璟', '背', '招', '矢', '梗', '痨', '桺', '蜜', '忽', '羊', '貊', '淫', '搔', '闽', '攥', '捉', '淖', '妄', '款', '兀', '柙', '蜓', '跹', '这', '瞋', '茬', '帘', '怩', '嗥', '裨', '阀', '嵯', '瑰', '队', '讨', '瞓', '囡', '佰', '早', '卞', '旌', '利', '筹', '烦', '撅', '汎', '叶', '翰', '咒', '陌', '钝', '倾', '瘠', '雄', '穑', '贷', '冀', '溃', '究', '扰', '邱', '癫', '会', '簌', '蹿', '烫', '阄', '闯', '览', '揻', '丘', '惗', '薰', '糅', '驭', '阕', '狸', '楂', '蛛', '众', '飒', '灌', '珐', '蔬', '猎', '遒', '吮', '霓', '垫', '姑', '濮', '亭', '旎', '遴', '策', '但', '酗', '麝', '砑', '灰', '叩', '忱', '妥', '耿', '遢', '挢', '绮', '嗵', '拟', '诨', '而', '呗', '疡', '黼', '篓', '浠', '褡', '少', '荤', '恫', '芋', '嫰', '仔', '嗡', '捭', '蜊', '涰', '俚', '丰', '錾', '负', '阱', '沱', '捞', '猝', '吹', '涎', '濠', '汔', '频', '烁', '崭', '馆', '蜢', '俱', '枪', '骚', '易', '剩', '惊', '篌', '寨', '牲', '枭', '豢', '扛', '徐', '桎', '扶', '誉', '耐', '褿', '耗', '淀', '恕', '砧', '乕', '拍', '孳', '摄', '窖', '肥', '靖', '铗', '蛾', '藤', '瘴', '逶', '催', '躯', '骏', '陟', '段', '鼎', '挣', '氅', '饵', '雌', '觎', '鹉', '胆', '臆', '春', '淅', '躲', '踊', '细', '绝', '殇', '肩', '通', '斓', '囟', '凸', '呕', '伤', '肖', '鉴', '犀', '唬', '颔', '肚', '如', '诧', '枸', '缧', '裆', '棼', '郄', '皂', '馑', '套', '餍', '海', '屹', '席', '北', '挛', '那', '贯', '氨', '舌', '竺', '揩', '眆', '榷', '乇', '栖', '呱', '料', '纤', '醺', '容', '碓', '价', '排', '犁', '须', '雏', '绊', '攻', '史', '萃', '陶', '鸬', '毒', '绠', '颌', '孤', '扦', '遣', '治', '腻', '貌', '琳', '佬', '遍', '牍', '历', '淌', '嘃', '殷', '毙', '龈', '韬', '榈', '烷', '茔', '腌', '虫', '淮', '飕', '郸', '缕', '弧', '斧', '善', '溺', '儆', '翘', '饲', '影', '黎', '禹', '榛', '针', '嫔', '芟', '生', '鲵', '磔', '裤', '毋', '寝', '黔', '抟', '揠', '洼', '岽', '琅', '荙', '诏', '裁', '痄', '骰', '伊', '染', '涅', '堙', '壹', '楼', '赧', '合', '崆', '接', '莎', '洋', '浮', '峋', '咫', '鲠', '缄', '穝', '寰', '峡', '媸', '瀑', '佯', '佥', '髻', '娼', '午', '笆', '争', '妍', '遯', '韧', '喋', '阒', '印', '骀', '作', '索', '姥', '鲨', '浩', '胼', '柏', '辊', '秀', '焜', '隐', '艄', '灯', '袍', '鞠', '油', '袜', '披', '聪', '非', '绨', '羹', '簇', '肺', '厥', '隔', '廊', '处', '嵕', '胶', '骨', '暮', '呷', '梁', '枝', '概', '吒', '涿', '烬', '噩', '充', '碟', '拂', '哭', '丙', '纹', '篦', '女', '视', '缤', '蛎', '墩', '郑', '棉', '橘', '幅', '殻', '臀', '辫', '涪', '跋', '梢', '垦', '读', '遐', '跳', '弑', '橐', '努', '揣', '吆', '恐', '窈', '晨', '蝈', '踉', '诱', '佩', '煤', '躇', '辍', '涧', '惚', '娇', '涝', '赶', '镒', '尹', '酊', '羡', '畲', '掂', '祠', '盎', '磊', '瓢', '牺', '堆', '涂', '栽', '司', '霭', '鈉', '很', '竖', '瞅', '筵', '盏', '汁', '珑', '掘', '闰', '烈', '汉', '碘', '嗤', '嶂', '滥', '火', '訇', '和', '嘻', '钵', '盛', '莼', '秸', '登', '椒', '椰', '给', '密', '仵', '懿', '歼', '差', '砖', '昵', '勤', '鹪', '图', '蔓', '钓', '坏', '矜', '峒', '莹', '泮', '揉', '搠', '贸', '瓶', '稔', '谯', '妗', '笃', '昆', '鹫', '胧', '趣', '哽', '舂', '裘', '秉', '芎', '笸', '角', '撼', '缺', '押', '朴', '静', '毛', '凳', '倒', '义', '示', '织', '钉', '军', '钗', '酞', '茵', '麋', '兽', '丢', '异', '咳', '敛', '酉', '醜', '穹', '苟', '噘', '止', '鬃', '汾', '呣', '迈', '傅', '蓑', '哼', '馕', '疏', '吠', '熏', '啷', '铛', '刊', '麓', '匚', '襄', '撮', '抹', '掺', '碧', '炀', '凶', '磬', '杉', '馄', '搞', '张', '迩', '鲢', '响', '俾', '馈', '绷', '施', '衍', '吇', '莛', '顽', '忌', '附', '盹', '喾', '鲭', '茴', '手', '橙', '巽', '粗', '簪', '帮', '盤', '驴', '郢', '痰', '盟', '蜀', '贲', '骑', '诎', '诽', '庄', '镀', '搐', '源', '著', '妃', '浸', '牢', '只', '峣', '条', '衙', '藉', '鹜', '黛', '肈', '原', '了', '宇', '圪', '憷', '悬', '饯', '矶', '最', '崔', '擘', '螟', '录', '珥', '狼', '谢', '熘', '磕', '蚶', '玺', '输', '乖', '主', '蹶', '炬', '表', '挥', '块', '徘', '赞', '窝', '夫', '闻', '持', '谜', '雀', '厚', '畸', '梳', '佧', '撰', '赈', '芹', '截', '寻', '穰', '苇', '厮', '聱', '赅', '范', '度', '噔', '陬', '多', '东', '阂', '闲', '藿', '萘', '婿', '模', '襟', '纸', '伎', '舔', '哩', '卉', '册', '欺', '为', '橡', '阋', '璇', '俯', '鸽', '窥', '杻', '惘', '沈', '爹', '嵩', '慈', '氖', '尾', '屦', '颉', '駡', '骷', '硗', '隼', '辛', '章', '裹', '骋', '窟', '甥', '溢', '唱', '嫩', '茼', '笔', '澄', '宾', '锌', '葬', '伞', '互', '贵', '象', '预', '垣', '央', '趁', '鹰', '傻', '擦', '凌', '圆', '鹏', '辢', '妒', '拷', '魏', '娩', '她', '廷', '梦', '荸', '嵌', '谫', '降', '炭', '满', '髓', '餮', '契', '炳', '空', '笊', '氤', '鲁', '掀', '监', '悸', '趴', '怜', '匝', '湧', '状', '病', '抻', '蹈', '蝲', '雹', '扇', '底', '茅', '舰', '鳊', '绌', '醮', '懵', '唑', '诡', '鸨', '渡', '健', '斡', '瑕', '戛', '毡', '红', '杖', '蹬', '烤', '伪', '垩', '蜗', '剁', '卧', '始', '送', '咄', '店', '便', '堞', '恪', '仡', '迭', '阮', '臂', '槌', '墉', '烽', '矩', '葡', '扩', '豸', '铃', '壳', '拒', '轰', '仞', '氛', '蝮', '老', '技', '清', '宦', '础', '蛮', '陪', '岁', '襁', '霎', '哦', '裳', '浊', '靠', '韭', '漠', '边', '俘', '断', '拌', '精', '滨', '摔', '撴', '莨', '毖', '摧', '煎', '醯', '疑', '立', '搅', '巾', '悛', '憋', '描', '批', '惆', '也', '睃', '掸', '滁', '诠', '钎', '睽', '啊', '画', '羁', '敓', '叟', '萏', '蓟', '鼻', '炖', '筚', '熄', '物', '柯', '侧', '袭', '钹', '胞', '舷', '缛', '胀', '霈', '熥', '槛', '遊', '鳕', '僮', '篁', '檩', '泪', '籼', '帔', '芡', '禁', '嗽', '现', '踅', '僳', '搜', '循', '膻', '函', '舫', '秩', '椅', '礁', '叽', '锻', '祟', '膏', '柢', '绅', '嗖', '携', '诸', '笏', '衷', '肋', '赁', '换', '聋', '挨', '吕', '荞', '尖', '所', '摒', '荀', '逻', '龛', '糨', '蠕', '枚', '犿', '藩', '婶', '提', '嚣', '定', '耆', '结', '皙', '学', '检', '庐', '游', '砣', '拼', '净', '豪', '凝', '薮', '堡', '朵', '仍', '一', '莴', '岸', '驼', '达', '沐', '嘭', '饔', '茄', '财', '速', '隍', '徨', '柒', '矿', '德', '猊', '矣', '痋', '乙', '横', '疱', '渺', '交', '氧', '局', '蹋', '诒', '烩', '孕', '胭', '种', '完', '啕', '轱', '墟', '菜', '轧', '扮', '硝', '瘟', '嘈', '沅', '称', '孝', '苘', '螺', '鎚', '刘', '眼', '平', '渤', '琵', '姹', '陈', '檄', '锸', '赎', '鲆', '亟', '烙', '尘', '讶', '砢', '挝', '咆', '淇', '隋', '赜', '汞', '黝', '磋', '赵', '攫', '洛', '狂', '疥', '绕', '即', '龇', '婺', '雪', '斑', '湔', '摊', '叁', '顺', '术', '溲', '呸', '练', '八', '倜', '予', '逅', '釜', '砾', '旗', '承', '秆', '秽', '纯', '树', '舵', '臧', '舄', '镢', '均', '粟', '螳', '帅', '退', '刷', '烘', '喂', '盐', '佘', '裔', '埝', '刿', '抽', '泸', '耪', '幌', '聚', '丝', '遂', '掮', '全', '碱', '隳', '鲥', '脾', '汀', '谰', '摈', '屐', '孱', '议', '勘', '县', '蒹', '谤', '瓷', '钳', '彬', '炮', '搓', '傀', '碉', '丹', '片', '姜', '泍', '器', '蚣', '买', '糜', '伙', '藻', '股', '昏', '醊', '驻', '殖', '间', '卖', '剐', '蔗', '马', '辈', '丐', '瘫', '蹩', '陕', '缴', '报', '社', '谆', '统', '傲', '屑', '烆', '足', '楹', '谙', '擅', '椿', '爵', '档', '贱', '坚', '绑', '警', '证', '个', '虢', '鸯', '荣', '票', '袒', '哟', '葵', '彤', '涡', '裎', '苑', '掣', '渎', '蹉', '垠', '窍', '紧', '景', '晕', '稲', '蠡', '嘚', '枵', '枣', '摁', '潢', '縻', '怯', '躺', '玄', '得', '雳', '娄', '骗', '诂', '压', '肼', '斥', '陑', '强', '甩', '蠖', '樇', '佻', '末', '魅', '枳', '萸', '窘', '盲', '显', '延', '柳', '沾', '骠', '脍', '靥', '艾', '跛', '委', '啬', '搦', '窃', '斩', '夙', '夕', '眦', '髂', '鞫', '爻', '砭', '贮', '嶙', '观', '彦', '於', '铐', '鲐', '詹', '敝', '劾', '新', '笈', '宽', '瞄', '锣', '忙', '隅', '峪', '贤', '猿', '综', '桉', '砒', '暹', '膜', '奉', '私', '导', '嫂', '殡', '螫', '框', '猕', '郦', '矬', '骧', '嫌', '谀', '叉', '蟑', '瑶', '孚', '诵', '柚', '叙', '扭', '芪', '孜', '悭', '盗', '雁', '矗', '改', '衽', '煌', '育', '夏', '瞻', '哑', '坊', '益', '畦', '餐', '寸', '耨', '熟', '告', '拱', '来', '僚', '码', '唧', '创', '澡', '鬟', '节', '沸', '毽', '炫', '曰', '瑜', '务', '疮', '医', '颐', '溜', '繇', '赠', '冈', '狈', '谄', '眺', '引', '兰', '兠', '绶', '庸', '富', '酣', '溅', '办', '邯', '讽', '放', '碾', '凍', '陵', '踵', '匣', '优', '获', '恢', '瓦', '凰', '忪', '复', '桓', '圻', '豹', '绯', '囚', '螃', '埠', '致', '晒', '銮', '鸷', '耄', '二', '旱', '实', '砌', '埋', '泊', '穷', '篝', '闾', '鲻', '烹', '芜', '峰', '钽', '啶', '滋', '把', '茆', '两', '蔚', '竟', '蛇', '掉', '倕', '缉', '氲', '娲', '阔', '薪', '穴', '泔', '俄', '奧', '鲲', '惧', '点', '钮', '政', '凿', '苄', '泻', '揄', '事', '福', '涯', '哏', '扪', '燎', '突', '汪', '冤', '娆', '谋', '岑', '书', '刑', '仃', '悌', '掳', '躞', '许', '故', '捆', '捏', '唆', '敬', '筌', '派', '谟', '屉', '肃', '莞', '箫', '窨', '鼐', '腥', '抗', '恶', '氯', '忍', '剃', '侥', '牀', '抚', '碣', '枯', '蚓', '鞭', '铀', '判', '峨', '冽', '吩', '缟', '重', '萍', '厂', '踩', '迥', '田', '筱', '痞', '羿', '抬', '铄', '瓜', '翌', '迪', '猜', '道', '嗣', '肤', '刃', '娠', '耸', '假', '驰', '嘡', '舶', '蚩', '妞', '萨', '咝', '寄', '皮', '躬', '付', '羟', '救', '榻', '纡', '澎', '窜', '抑', '郫', '佑', '苗', '填', '硼', '去', '威', '逑', '措', '绒', '眵', '到', '酿', '卦', '栩', '瞿', '聿', '碗', '孫', '凡', '虽', '傥', '蚕', '奥', '冕', '恒', '锚', '窠', '文', '拿', '蛙', '觉', '芯', '匡', '叱', '寡', '审', '胛', '战', '河', '铆', '正', '万', '杂', '廿', '茭', '吭', '左', '踔', '榴', '颚', '鸣', '悯', '觑', '耷', '量', '服', '博', '怀', '巿', '渴', '咯', '领', '岷', '彀', '糟', '畜', '兑', '镂', '膳', '扫', '苦', '鸟', '狠', '茱', '犒', '泠', '稍', '渲', '揭', '艺', '邦', '狎', '铿', '剂', '猩', '肛', '航', '透', '侔', '厝', '部', '佴', '厕', '袪', '哞', '珧', '毳', '汛', '狱', '装', '亲', '褶', '首', '莳', '难', '湖', '喀', '弈', '箜', '焊', '髦', '壑', '劫', '觞', '奋', '启', '罅', '鳜', '肠', '禀', '夯', '脚', '酌', '素', '擎', '蛆', '前', '塞', '娜', '环', '廾', '涤', '龉', '摘', '插', '帏', '瘘', '箱', '旖', '太', '噜', '括', '葆', '旷', '憧', '译', '犷', '搭', '虑', '呻', '屈', '墙', '刻', '怅', '屠', '嫣', '汴', '搬', '饿', '跷', '旮', '觌', '衣', '箧', '夤', '讷', '鸢', '俏', '噶', '锦', '淋', '绔', '涟', '君', '娘', '熙', '楚', '坝', '浅', '徽', '叔', '家', '温', '埙', '韪', '乘', '潺', '疙', '煺', '羽', '砍', '跺', '碴', '鱿', '黜', '虮', '疹', '腭', '讓', '枧', '谭', '抛', '初', '戕', '帽', '谘', '驽', '菽', '啁', '锭', '坟', '翁', '佤', '奸', '榕', '殂', '苹', '休', '狐', '防', '师', '蹼', '宿', '骼', '罩', '礴', '甭', '御', '柝', '浜', '险', '质', '漏', '萎', '翩', '乓', '味', '坡', '核', '妮', '苯', '五', '蓦', '洇', '桦', '论', '枢', '粜', '柩', '妓', '撂', '炎', '谒', '祷', '哌', '沼', '顷', '野', '什', '昂', '胚', '捐', '舀', '寮', '胝', '蛀', '拦', '甲', '粹', '滓', '煅', '畴', '问', '衲', '芳', '着', '却', '辉', '俇', '潭', '篪', '类', '继', '髅', '具', '怆', '矽', '蚁', '梧', '瓠', '锲', '井', '饱', '应', '馨', '妨', '肐', '缓', '硕', '啥', '秋', '蚌', '援', '朱', '崤', '锷', '庖', '桃', '勉', '岱', '吉', '奏', '瘾', '腾', '击', '释', '痼', '咸', '翡', '顼', '鄣', '卡', '癸', '挠', '枕', '蜒', '吋', '纬', '绫', '玻', '泽', '歪', '蜍', '湛', '桷', '箸', '竣', '奎', '写', '握', '睛', '裢', '刎', '愚', '芬', '馊', '唐', '毓', '咪', '昊', '探', '劬', '楔', '酩', '蓝', '挪', '双', '樟', '津', '痉', '楸', '捡', '蹴', '庚', '铑', '坉', '膦', '巴', '棒', '龋', '筒', '枇', '栈', '姻', '鹑', '镁', '错', '进', '藜', '漾', '哈', '莸', '蓉', '慎', '澌', '烯', '矫', '牴', '伴', '侨', '瞬', '烛', '苛', '槭', '赛', '快', '崛', '濋', '愎', '砸', '褪', '卓', '罐', '的', '苋', '痤', '约', '场', '呛', '伍', '铬', '闱', '嵬', '萼', '睾', '勃', '又', '芸', '蜡', '拽', '捋', '缀', '蚍', '栋', '庙', '巢', '瘩', '亡', '俞', '豉', '缸', '铩', '鳞', '獭', '麈', '飧', '篡', '谕', '硬', '蜃', '垒', '颊', '怠', '禾', '澧', '匐', '蘑', '鸿', '腕', '渣', '鹅', '锁', '深', '剖', '耶', '狮', '兵', '蠢', '魁', '逋', '跶', '泡', '菁', '胖', '荧', '蹲', '濞', '殿', '噎', '寞', '倩', '瘢', '茏', '胰', '婆', '迎', '绎', '蔫', '朦', '酱', '庒', '嫒', '杈', '踱', '曜', '蜘', '竦', '皲', '娴', '湃', '拈', '胡', '圳', '资', '媚', '瞠', '殃', '钙', '求', '郐', '岩', '抨', '折', '懂', '乒', '蓖', '葚', '儡', '翱', '枋', '屣', '沁', '崩', '开', '鞥', '税', '儒', '徂', '挂', '霉', '氽', '帐', '茫', '涮', '羼', '幕', '蝗', '腔', '缁', '雩', '砷', '时', '浒', '拳', '撷', '闵', '朐', '暂', '逛', '霾', '萦', '镚', '髭', '名', '克', '涣', '芘', '啖', '痳', '噱', '稽', '好', '稻', '恤', '湎', '姓', '嗐', '孢', '镣', '馅', '嫠', '踣', '喝', '踺', '栏', '鲜', '诺', '茹', '鼑', '捷', '彭', '卸', '匈', '覃', '沉', '记', '榜', '薷', '村', '逾', '党', '般', '归', '卺', '廖', '摉', '赔', '残', '脱', '獒', '邢', '症', '趟', '菲', '锨', '镨', '邺', '试', '巍', '潸', '较', '巫', '彻', '必', '牵', '畀', '遑', '弛', '巷', '址', '迸', '僭', '歃', '哒', '渫', '芽', '忻', '遽', '斐', '韩', '贬', '匍', '然', '霸', '役', '能', '哆', '啱', '吴', '忡', '饶', '铧', '彩', '膑', '志', '叭', '院', '衫', '璨', '疲', '辖', '褫', '瞌', '鲫', '封', '鳗', '柔', '蒿', '墓', '艘', '燕', '擗', '峭', '阙', '汶', '硈', '岐', '皿', '翕', '狍', '熵', '噤', '嘴', '版', '矸', '姗', '客', '之', '蹯', '烂', '尤', '柬', '怕', '芝', '鲇', '些', '抠', '偃', '谬', '祇', '祝', '踏', '蝌', '俎', '曙', '芍', '投', '翦', '校', '谁', '哲', '基', '箭', '尿', '分', '溪', '煲', '糺', '班', '邵', '悄', '犴', '林', '宗', '绩', '睐', '慑', '看', '搽', '蛤', '戗', '玳', '扣', '揆', '滑', '久', '悴', '苌', '妇', '估', '里', '褛', '岳', '柜', '厨', '悻', '声', '活', '恻', '泳', '撕', '轼', '驹', '摸', '体', '揖', '峙', '咿', '爨', '菏', '嗯', '谨', '筷', '硐', '虏', '膂', '兼', '垛', '萤', '懒', '郭', '仆', '颠', '梱', '虺', '丁', '伥', '晴', '蝉', '鸩', '替', '螨', '阳', '猪', '拣', '赚', '赏', '弁', '钾', '蠲', '谊', '萱', '铳', '济', '遛', '建', '濆', '鹤', '涵', '纱', '兹', '佼', '型', '铒', '线', '昙', '齌', '暖', '震', '娥', '择', '叼', '唉', '置', '痢', '帧', '踞', '拗', '赴', '员', '棍', '嚓', '罴', '贡', '胳', '法', '月', '怫', '氏', '沮', '谅', '曼', '键', '绵', '紊', '郡', '糁', '床', '燮', '违', '垮', '射', '大', '楫', '忾', '琥', '镞', '溯', '沦', '冻', '娃', '劲', '誊', '熨', '牤', '荒', '煞', '菑', '饽', '吓', '向', '庵', '酆', '蕤', '暇', '潜', '尥', '襙', '榫', '袄', '孽', '潘', '匠', '锈', '肴', '黏', '雍', '钜', '杳', '噢', '莒', '顶', '雉', '普', '链', '筑', '岂', '朋', '镲', '绣', '鬓', '焖', '柫', '镑', '弓', '饥', '剥', '混', '困', '瘀', '殚', '嘬', '陲', '镐', '惨', '败', '知', '臊', '旃', '鸾', '趄', '倨', '跖', '晶', '泣', '验', '泌', '额', '翎', '播', '金', '序', '盖', '泵', '州', '情', '偶', '旦', '腮', '怿', '梭', '痦', '杠', '眶', '醉', '饕', '匮', '琼', '蹭', '墒', '娌', '旯', '谐', '喷', '铭', '熔', '纭', '擞', '制', '卅', '造', '灿', '士', '呵', '渗', '拆', '莱', '辟', '坑', '懊', '肿', '沔', '胱', '窿', '瞟', '伉', '杞', '槿', '薏', '曺', '栗', '剔', '肮', '擤', '闪', '么', '散', '眄', '斫', '伟', '猷', '绥', '漱', '甜', '倭', '慗', '崴', '箴', '撞', '笫', '皱', '檐', '汜', '淬', '婊', '靛', '楷', '萧', '诅', '辨', '唁', '奔', '迦', '儿', '梅', '怂', '拢', '欲', '丑', '访', '菩', '赍', '父', '纰', '藐', '旭', '皎', '穆', '馥', '献', '亦', '鼓', '各', '磅', '洪', '瑟', '蚯', '甑', '徊', '蹚', '羰', '血', '乎', '噫', '瑯', '牒', '镌', '奴', '粼', '褒', '濡', '峯', '癣', '因', '嗑', '邀', '官', '扔', '劝', '痊', '拎', '绢', '上', '绪', '笤', '锢', '阗', '陇', '疆', '揽', '魉', '甬', '秃', '凑', '榔', '鲩', '余', '宵', '炼', '川', '烜', '蹒', '授', '啄', '垄', '拮', '蕴', '佟', '省', '坷', '连', '更', '添', '样', '痕', '佝', '藕', '变', '咛', '喆', '啾', '帙', '葙', '酪', '廓', '鳃', '于', '笥', '捧', '镯', '尓', '濒', '跚', '巨', '稳', '欣', '鹎', '邹', '錎', '辏', '剪', '鸡', '穿', '饭', '代', '痴', '敢', '滴', '挞', '靼', '吃', '徵', '它', '镇', '牧', '碳', '贼', '蚤', '卜', '纺', '呢', '迄', '至', '荛', '忲', '凋', '玫', '淆', '菡', '阻', '匪', '随', '驷', '咽', '晤', '蚬', '猥', '醛', '呲', '痣', '捍', '曝', '允', '琴', '蛊', '慢', '孥', '围', '胯', '十', '既', '超', '戳', '浦', '钩', '懦', '搏', '糙', '丈', '嘞', '牝', '咧', '殉', '摆', '蛰', '幄', '坞', '笨', '映', '蝶', '楱', '犯', '鞅', '獾', '惮', '膛', '佛', '爸', '您', '注', '爼', '苩', '砘', '胃', '匆', '龚', '侏', '颁', '候', '葜', '崞', '奚', '栅', '鹨', '鲺', '沃', '浃', '椁', '檀', '责', '反', '钡', '忸', '失', '揶', '稇', '愿', '陆', '邓', '俪', '槍', '白', '饣', '赓', '兮', '癌', '鲍', '姿', '擀', '赤', '馁', '祯', '椹', '甚', '淹', '啡', '岵', '猾', '乾', '恋', '百', '杆', '忿', '姨', '佳', '痿', '栟', '殁', '咤', '琊', '槊', '篑', '糯', '冒', '嗔', '遵', '腹', '沧', '瑙', '憬', '塘', '俟', '脂', '抖', '痈', '集', '绽', '嗝', '撤', '怔', '篱', '愉', '眩', '泄', '革', '馓', '伺', '颇', '屡', '皋', '缆', '另', '液', '恬', '酒', '菇', '旄', '鯭', '坛', '商', '弘', '蝼', '梻', '翠', '死', '殊', '蹁', '邸', '蛔', '亘', '侉', '燔', '蒙', '星', '湍', '浓', '凯', '竹', '峻', '谈', '绛', '其', '葳', '消', '诙', '是', '凭', '脐', '楮', '砺', '蛹', '姘', '莠', '蕃', '龅', '讵', '波', '纠', '卩', '阉', '麾', '纳', '袁', '彷', '惭', '当', '竭', '弊', '过', '戎', '徜', '腺', '绺', '赋', '龃', '旧', '怦', '古', '衔', '盔', '肇', '舆', '愤', '痘', '搪', '饩', '费', '烊', '兜', '包', '婷', '汗', '冬', '咀', '恩', '鹗', '倌', '榄', '砝', '豁', '媳', '桐', '霁', '鬼', '弩', '蠹', '潼', '辑', '未', '舒', '讣', '袱', '避', '鄱', '芫', '湿', '葑', '瞪', '租', '徙', '挺', '渚', '佣', '煸', '偈', '署', '哫', '蝴', '佐', '贺', '擢', '抉', '膨', '疵', '蒸', '铜', '嚼', '悔', '蜉', '梯', '笑', '惺', '崂', '丞', '艮', '束', '蚊', '戚', '气', '轿', '咂', '淡', '栓', '仟', '撺', '腑', '戾', '愦', '漆', '敖', '吊', '妖', '愁', '想', '咚', '出', '涨', '呐', '旆', '啼', '娟', '宫', '真', '赝', '氓', '厢', '谑', '怖', '粢', '拧', '驿', '殆', '谍', '扯', '茉', '炉', '朗', '旇', '炕', '箐', '麸', '悖', '晓', '缰', '讲', '蟠', '舛', '歘', '山', '经', '祖', '怛', '呈', '玛', '梏', '签', '狴', '奄', '由', '男', '尴', '砰', '唳', '刁', '鵰', '拴', '考', '锃', '埃', '凹', '蜕', '幡', '缨', '莓', '罱', '蔁', '慷', '亮', '馍', '阅', '激', '苓', '申', '妩', '涩', '齐', '穈', '值', '鳎', '京', '涸', '蔑', '鸭', '呼', '勒', '琐', '解', '浆', '闭', '蹀', '喜', '肝', '幺', '木', '简', '锹', '闫', '工', '谌', '烃', '弹', '燫', '存', '哺', '剧', '果', '哪', '飙', '筛', '醪', '蛉', '沏', '晁', '吐', '豇', '储', '裼', '直', '睫', '涔', '诮', '尉', '蹙', '蟀', '此', '长', '疼', '靴', '嗉', '殄', '铠', '馐', '拥', '炝', '镜', '弱', '我', '黄', '根', '螽', '岖', '乌', '几', '岿', '趔', '泉', '找', '订', '形', '弼', '岌', '贴', '霹', '嘹', '距', '矮', '驮', '绦', '撸', '产', '酚', '灶', '罿', '阐', '惰', '傫', '皑', '宠', '职', '恼', '屏', '匿', '阖', '璞', '茸', '泅', '媾', '蜿', '浪', '瘸', '陋', '喙', '诋', '摩', '唝', '喇', '蚵', '戍', '句', '己', '痛', '诈', '酥', '笺', '康', '鳅', '哝', '瞎', '划', '沓', '憨', '眈', '帆', '半', '测', '寒', '远', '酋', '瞽', '啻', '熰', '洒', '虿', '汝', '骖', '雅', '刳', '楣', '羯', '簿', '嗬', '拙', '玖', '戢', '镶', '髯', '谦', '惑', '胸', '莆', '鄂', '缔', '珊', '偎', '婉', '冗', '歩', '葩', '鲎', '窦', '盈', '粮', '暧', '恨', '塌', '绁', '恭', '锡', '梓', '瘊', '橄', '哧', '幔', '闺', '污', '介', '麻', '聃', '牌', '微', '宜', '屌', '瑞', '迷', '伫', '懈', '姚', '配', '朊', '曾', '昭', '疗', '栉', '喏', '保', '亢', '翟', '痹', '蕾', '饨', '暄', '辕', '谠', '腼', '罔', '硌', '姊', '毫', '牞', '逗', '曳', '诗', '铣', '鸥', '暝', '虻', '瞳', '筏', '词', '隧', '妾', '成', '谓', '慰', '嗷', '锄', '啃', '婵', '粲', '天', '垢', '郎', '尚', '隽', '听', '陷', '嗅', '径', '酶', '窗', '睿', '湘', '飘', '沽', '酵', '滞', '晌', '拭', '减', '俭', '货', '茯', '秤', '箕', '盾', '诘', '隆', '返', '关', '蕨', '尧', '豌', '水', '壮', '略', '江', '缪', '都', '悱', '逹', '胄', '揎', '札', '禺', '諾', '禧', '葭', '特', '皴', '露', '剜', '尻', '程', '芦', '罗', '渑', '评', '吟', '伏', '佚', '爰', '棚', '项', '醚', '搴', '冲', '酷', '歹', '鸫', '庑', '蝎', '胺', '庞', '骂', '咡', '葺', '郊', '锟', '闸', '怏', '唢', '爷', '室', '仿', '娑', '淄', '偬', '缝', '呜', '琪', '蹇', '维', '钻', '尽', '迢', '荷', '龊', '墨', '晚', '塔', '昱', '府', '鹌', '婴', '锥', '吨', '食', '舱', '倍', '瞒', '艳', '罢', '衬', '淳', '饧', '魍', '匹', '啜', '黥', '娓', '笛', '膘', '助', '尝', '汩', '桔', '零', '裂', '丫', '庇', '惯', '赫', '蛄', '荨', '裙', '悲', '遏', '让', '缣', '涌', '睡', '渝', '玡', '鳔', '胴', '昇', '妈', '占', '轻', '脯', '婤', '九', '终', '敌', '隗', '莺', '碲', '箔', '盆', '穗', '飱', '鲶', '仅', '罕', '秒', '铅', '敦', '唤', '疽', '肓', '守', '钧', '俊', '棘', '宪', '惟', '郰', '爱', '掩', '旁', '虔', '昃', '雇', '圾', '吱', '屿', '杵', '巳', '乳', '娶', '崖', '丽', '椎', '需', '撬', '辱', '站', '桂', '湾', '青', '幸', '驾', '鹮', '鏂', '犸', '演', '侩', '捕', '遁', '燥', '卫', '濯', '锉', '掇', '渭', '祉', '鸦', '蜴', '雾', '泱', '徼', '跎', '耋', '鳄', '颛', '茇', '诛', '嗓', '旰', '嘘', '赘', '鼷', '蒺', '常', '缫', '侬', '逮', '率', '纂', '份', '西', '骛', '贿', '豚', '尔', '友', '融', '收', '咙', '倦', '煽', '咎', '硫', '觥', '镬', '帼', '齿', '兕', '斋', '厉', '妲', '惕', '觐', '粝', '侵', '癞', '歉', '茂', '柄', '缢', '训', '令', '慧', '臣', '亏', '礼', '汕', '牦', '嗒', '愠', '劓', '符', '篷', '芮', '荼', '狞', '蝙', '扑', '嚏', '寥', '窣', '乏', '鲞', '帱', '锅', '饼', '嘲', '眸', '植', '灾', '啤', '漳', '菊', '戡', '逖', '浑', '锤', '虾', '趾', '桡', '构', '撵', '阪', '熹', '国', '醇', '焕', '隙', '啦', '头', '跏', '忠', '滩', '噼', '外', '牟', '闷', '苶', '曹', '睦', '岭', '揪', '怙', '毂', '轫', '阡', '渊', '修', '颧', '农', '蝇', '惜', '粑', '糌', '隶', '竿', '喊', '妁', '廉', '哮', '蜇', '垃', '蟋', '孔', '宴', '筲', '姆', '袂', '螂', '跟', '加', '埔', '刹', '裱', '掎', '皖', '呦', '诓', '羸', '中', '滢', '沌', '感', '仫', '禄', '哄', '屁', '飞', '幂', '磺', '侍', '榨', '诉', '副', '柑', '腆', '纫', '踯', '谧', '醍', '陡', '蹦', '冥', '馀', '鹳', '攒', '玉', '公', '呃', '仁', '舟', '缚', '溶', '帕', '坠', '朔', '庛', '茶', '韶', '冰', '菘', '推', '鼗', '趵', '翔', '赭', '谱', '伦', '柠', '棠', '奠', '赊', '樱', '茨', '镏', '瑁', '确', '杰', '羲', '斜', '布', '秧', '逃', '惩', '浣', '霄', '埂', '咨', '迳', '婄', '近', '算', '肪', '鹦', '障', '狙', '堪', '媛', '窬', '枘', '励', '诫', '机', '锵', '尺', '霍', '案', '阵', '赃', '唯', '信', '姬', '颡', '次', '夸', '总', '扳', '勿', '肾', '珞', '扬', '暴', '俩', '茧', '簧', '铺', '耍', '杀', '啰', '偏', '瀛', '烧', '虹', '弋', '骡', '迤', '怒', '畔', '饫', '唾', '粕', '界', '蜥', '鹭', '抢', '爽', '噪', '从', '蕉', '鱼', '峇', '控', '糖', '缅', '淸', '椟', '辞', '劣', '决', '荔', '秘', '缩', '镊', '享', '沲', '倏', '霞', '碌', '睑', '页', '电', '晦', '拾', '瞰', '摇', '捺', '粳', '窒', '脖', '权', '免', '帖', '韫', '茠', '杼', '娉', '薄', '彼', '润', '美', '卯', '偿', '捣', '市', '坐', '期', '硎', '囍', '蹂', '馋', '蔽', '诀', '卷', '壶', '貂', '轲', '嚯', '徭', '齑', '黠', '辣', '侣', '赀', '矾', '胫', '羔', '僧', '念', '今', '逡', '番', '麟', '销', '胜', '掐', '羞', '痍', '恅', '挫', '歙', '掷', '荐', '绞', '荻', '孰', '耙', '氢', '像', '啸', '滇', '孩', '拜', '吾', '漂', '再', '明', '囔', '炊', '焙', '蒋', '荦', '苕', '热', '指', '夷', '宁', '耻', '宅', '黧', '抓', '怡', '滔', '肌', '祜', '乜', '啮', '矅', '欧', '萄', '钱', '猖', '他', '裕', '绚', '弍', '卒', '阁', '地', '虞', '或', '尊', '趼', '屯', '球', '哗', '鸳', '花', '馔', '顇', '躏', '疸', '单', '腩', '夜', '氮', '有', '挟', '破', '苍', '嵘', '瓅', '焰', '慵', '毅', '魃', '妙', '荟', '菠', '弭', '跪', '及', '圃', '刍', '瘁', '併', '憎', '芤', '奁', '瑚', '碍', '膝', '蘖', '网', '曲', '铎', '越', '醤', '恍', '隘', '忖', '掖', '补', '啧', '届', '皓', '胎', '龟', '詈', '起', '遄', '傍', '数', '夺', '趿', '刖', '色', '蟥', '砥', '挹', '任', '糊', '触', '猫', '掏', '除', '偆', '贩', '遆', '裸', '聩', '闩', '殴', '智', '良', '蔡', '秣', '们', '喳', '跫', '臼', '坢', '缮', '匙', '英', '戒', '扎', '痔', '疣', '够', '勾', '旺', '溻', '伯', '帷', '脆', '郁', '迂', '茌', '锂', '氰', '讫', '备', '靡', '尸', '辙', '呀', '毗', '桨', '漕', '甍', '擐', '阜', '蒲', '锒', '粉', '路', '癜', '恿', '铮', '撒', '位', '赂', '寿', '嫦', '铵', '磐', '灸', '鱾', '赦', '翼', '鹺', '哥', '述', '侦', '居', '亨', '懲', '误', '贳', '下', '糗', '挤', '僜', '掌', '累', '灭', '咔', '踪', '邮', '耘', '猢', '钏', '促', '俦', '褂', '耕', '识', '樵', '嗦', '铡', '圭', '库', '捶', '鹬', '颈', '讴', '坂', '鳘', '毯', '蓓', '船', '楡', '颜', '旒', '罪', '佞', '停', '跗', '燧', '嘿', '妊', '涓', '塑', '且', '熠', '牙', '徇', '钨', '磷', '颏', '槁', '件', '祸', '坼', '况', '嵋', '话', '诤', '斗', '腱', '性', '恰', '玑', '惶', '忒', '辄', '仄', '赳', '喹', '摞', '账', '贪', '腧', '藓', '冼', '钠', '莘', '硅', '临', '骸', '棵', '酃', '弗', '每', '敷', '悍', '睢', '堰', '憾', '析', '匾', '苫', '镰', '迁', '纵', '葫', '倘', '载', '寓', '稼', '羮', '诬', '串', '斤', '叫', '讹', '孺', '籁', '债', '剽', '诳', '氐', '属', '米', '榇', '漩', '汤', '偕', '崽', '薨', '就', '莅', '蛲', '苣', '戏', '跬', '辜', '你', '蛋', '僵', '甄', '咋', '疯', '簸', '四', '捂', '字', '缠', '痱', '涠', '辂', '衡', '扃', '渐', '嘎', '拖', '獐', '稂', '岛', '钊', '籍', '晏', '栎', '岗', '肘', '桅', '哉', '子', '奍', '往', '眨', '酬', '渔', '奈', '低', '鼋', '亳', '鹊', '彗', '已', '嚎', '效', '瘗', '俸', '孙', '苡', '耳', '升', '态', '谚', '设', '矛', '舐', '泞', '蚂', '籽', '蓼', '咩', '逼', '掬', '狭', '侮', '恣', '镳', '鼾', '镫', '窸', '罄', '泐', '腋', '炽', '曷', '铸', '厩', '铙', '樯', '侈', '割', '忏', '察', '取', '喔', '捅', '哀', '喑', '狒', '阿', '辐', '箩', '卑', '澜', '嘉', '日', '馒', '含', '痂', '怨', '抒', '泰', '株', '涴', '肄', '执', '牖', '祁', '噻', '囫', '怵', '吵', '骓', '酮', '帚', '肯', '材', '迟', '芙', '焚', '劳', '管', '堕', '喻', '弄', '沿', '诲', '憯', '玲', '蟆', '认', '悠', '浴', '周', '滂', '丛', '轮', '痒', '翥', '踝', '庆', '吼', '敲', '吧', '厄', '挑', '询', '膊', '蹍', '橱', '嘟', '贻', '嘣', '憔', '鑫', '骤', '毕', '嗨', '蜈', '镖', '诶', '遥', '勇', '培', '刮', '械', '眯', '鬣', '衉', '贫', '轴', '药', '惬', '诌', '臻', '滚', '祥', '摹', '扉', '李', '菀', '棹', '桌', '豺', '猴', '捃', '痪', '纨', '咕', '洗', '使', '鹘', '逸', '嘛', '癖', '钟', '骐', '吻', '痧', '丧', '逝', '媲', '芷', '芒', '墅', '聂', '敞', '铂', '婀', '颤', '题', '憩', '挡', '觊', '害', '黻', '屋', '啪', '阑', '艇', '诰', '舢', '祛', '传', '慌', '癔', '朕', '犄', '囱', '托', '吝', '褴', '廋', '住', '参', '杷', '渍', '贝', '瓤', '驳', '孵', '移', '楠', '裴', '唔', '疖', '瓩', '抡', '玷', '暑', '离', '旋', '教', '土', '斌', '晖', '芥', '逢', '凤', '镝', '永', '菰', '瑾', '鹞', '蚪', '讯', '操', '忑', '斯', '洽', '陛', '奶', '坯', '棣', '葱', '喃', '柱', '联', '挖', '厘', '蕊', '蔼', '泼', '缜', '跆', '驱', '扥', '義', '莉', '弃', '绰', '舨', '捎', '殪', '池', '脽', '盥', '嚒', '篙', '晰', '浼', '腊', '轾', '叵', '糕', '劭', '冁', '络', '鬲', '腓', '铢', '卤', '偻', '俺', '琰', '俨', '碑', '覆', '纣', '并', '脏', '诣', '璧', '灬', '乞', '民', '光', '肫', '驯', '醋', '渠', '娱', '臺', '挲', '溷', '贾', '菱', '谛', '钺', '珍', '鹃', '皇', '傈', '三', '留', '龙', '飨', '沪', '氟', '迫', '杜', '虚', '晡', '啉', '侠', '偷', '芭', '相', '袤', '咐', '濛', '聊', '削', '柿', '团', '绿', '迅', '卿', '茗', '被', '默', '咦', '绘', '悚', '云', '罡', '氩', '戮', '枷', '崇', '珈', '蝠', '层', '蓄', '爆', '嘀', '狡', '搀', '咏', '幽', '奢', '辇', '宏', '圈', '沟', '转', '崎', '玦', '鸠', '獠', '膈', '鸪', '车', '冶', '妻', '乡', '螓', '瀣', '愈', '蜂', '该', '顿', '弯', '鼠', '否', '遇', '讪', '锐', '岚', '桩', '毁', '藏', '洱', '篆', '媒', '语', '撇', '喧', '侄', '艿', '踌', '闹', '轹', '者', '振', '喟', '媄', '镭', '忆', '搎', '髀', '攘', '倥', '桧', '银', '鞋', '黑', '炗', '瘦', '枫', '跑', '喉', '竽', '谏', '糠', '醒', '望', '请', '营', '希', '衢', '锯', '焯', '衩', '聘', '香', '恺', '灼', '嫖', '歌', '柞', '钿', '蕙', '瓮', '荆', '剌', '怄', '世', '孀', '衰', '整', '腈', '寤', '贰', '凉', '购', '舜', '浙', '麦', '惹', '拔', '阇', '耦', '陀', '惋', '溴', '锺', '跣', '沤', '煊', '华', '轩', '荡', '劈', '汹', '纽', '兢', '栲', '淼', '昼', '叨', '琨', '晾', '颦', '豕', '抿', '夭', '咴', '邃', '琢', '见', '奇', '业', '港', '冷', '荠', '厦', '瀹', '冠', '兆', '彘', '元', '境', '淤', '阶', '説', '窄', '钢', '粤', '旅', '忐', '趺', '厅', '鳖', '赌', '在', '步', '蚱', '栳', '膀', '邑', '桥', '刚', '肱', '臬', '谵', '将', '袋', '祭', '说', '眉', '支', '朝', '蒌', '鏾', '坍', '坨', '匏', '埴', '鲤', '寇', '稚', '群', '荏', '糍', '挈', '号', '式', '歇', '切', '吁', '歆', '阎', '囹', '入', '嬗', '褥', '蒡', '犟', '狲', '谴', '神', '缥', '按', '漓', '依', '淑', '千', '浇', '借', '悦', '寺', '澳', '仰', '苔', '惫', '哇', '燃', '粪', '仨', '宕', '适', '擒', '用', '傧', '蛟', '格', '遮', '饷', '愣', '妪', '柰', '患', '煨', '槟', '锋', '珠', '晃', '蛐', '钀', '蓬', '擂', '坪', '纶', '裾', '稷', '呓', '颓', '踮', '熣', '谲', '荫', '受', '季', '艰', '樊', '狰', '潮', '堂', '胬', '坤', '羚', '筋', '涛', '瘆', '裰', '习', '哎', '茕', '仗', '疫', '疟', '化', '靶', '吞', '栾', '潦', '端', '乔', '仪', '谗', '堵', '币', '龄', '右', '掠', '爪', '玟', '铰', '熬', '椠', '慨', '巅', '豆', '狄', '徉', '锑', '棂', '卵', '霖', '浏', '辽', '勺', '橛', '粽', '絮', '萝', '仕', '讳', '唰', '飓', '禅', '蔺', '徒', '严', '召', '挚', '盘', '玩', '禽', '组', '嫫', '饴', '纪', '瘤', '佃', '杨', '噬', '纲', '遭', '本', '罚', '乃', '追', '呯', '耠', '笙', '碎', '伶', '剿', '骁', '嫡', '无', '巡', '第', '揍', '咻', '七', '咬', '枓', '虐', '内', '诊', '轨', '别', '漫', '峥', '园', '伽', '豫', '婚', '黩', '宰', '喱', '刨', '跨', '没', '聢', '仲', '見', '闳', '秫', '抄', '荜', '惠', '爡', '刽', '运', '欢', '袈', '草', '盯', '勋', '人', '缭', '售', '瓣', '南', '箍', '域', '轳', '屎', '轸', '袅', '譬', '遗']

# chinese -> number
encode = dict(zip(list(chinese),range(0,len(chinese))))

# number -> chinese
decode_list = dict(zip(range(0,len(chinese)),list(chinese)))

Max_length = 1
chinese_len = len(chinese)

def decode(tgt):
    tgt = tgt.view(Max_length,chinese_len)
    idx = tgt.max(1)[1]
    ret = []
    for i in idx:
       num = decode_list[i.item()]
       ret.append(str(num))
    return ''.join(ret)

class MydataSet():
    def __init__(self,path,transform):
        self.path_list = [os.path.join(path,i) for i in os.listdir(path)]
        self.transform = transform

    def __getitem__(self, item):
        path = self.path_list[item]
        image = Image.open(path)
        if self.transform:
            image = image.convert('RGB')
            image = self.transform(image)

        name = os.path.basename(path).split('_')[0]
        label = [encode[name]]
        label2 = torch.tensor(label,dtype=torch.long)
        eye = torch.eye(chinese_len)
        ret = eye[label2]
        label = ret.view(-1)
        return image,label

    def __len__(self):
        return len(self.path_list)

def albumentations_transform(image):
    transform = strong_aug_Single_category(1)
    image_np = np.array(image)
    augmented = transform(image=image_np)
    image = augmented['image']
    return image

transform = transforms.Compose([
    transforms.Lambda(albumentations_transform),
])

def strong_aug_Single_category(p=1):
    return Compose([
        Resize(60, 60),
        RandomRotate90(),
        Flip(),
        Transpose(),
        OneOf([
            IAAAdditiveGaussianNoise(),
            GaussNoise(),
        ], p=0.2),
        OneOf([
            MotionBlur(p=.2),
            MedianBlur(blur_limit=3, p=0.1),
            Blur(blur_limit=3, p=0.1),
        ], p=0.2),
        ShiftScaleRotate(shift_limit=0.0625, scale_limit=0.2, rotate_limit=45, p=0.2),
        OneOf([
            OpticalDistortion(p=0.3),
            GridDistortion(p=.1),
            IAAPiecewiseAffine(p=0.3),
        ], p=0.2),
        OneOf([
            CLAHE(clip_limit=2),
            IAASharpen(),
            IAAEmboss(),
            RandomBrightnessContrast(),
        ], p=0.3),
        HueSaturationValue(p=0.3),
        ToTensor()
    ], p=p)

train_data = MydataSet(r'D:\data\new_geetest\train',transform=transform)
test_data = MydataSet(r'D:\data\new_geetest\test',transform=transform)
# import cv2
# im, lb = train_data.__getitem__(2000)
# print(im, im.shape)
# print(im.detach().numpy().shape)
# cv2.imshow("128x128", im.permute(1, 2, 0).detach().numpy())
# cv2.waitKey()

train_data_loader = torch.utils.data.DataLoader(train_data,batch_size=64,shuffle=True,num_workers=0,pin_memory=True)
test_data_loader = torch.utils.data.DataLoader(test_data,batch_size=16,shuffle=False,num_workers=0,pin_memory=True)

net = EfficientNet.from_pretrained('efficientnet-b4')
in_fea = net._fc.in_features
net._fc = torch.nn.Linear(in_features=in_fea, out_features=chinese_len, bias=True)
net =torch.load("model/chinese_new.pt")
model = net.to('cuda')


loss_func = torch.nn.MultiLabelSoftMarginLoss()
opt = torch.optim.Adam(model.parameters(),lr=0.0001)

for epoch in range(20000):
    bar = tqdm(train_data_loader)
    for i,(image,label) in enumerate(bar):
        # 获取最后输出
        out = model(image.cuda()) # torch.Size([128,10])
        # 获取损失
        loss = loss_func(out,label.cuda())
        # 使用优化器优化损失
        opt.zero_grad()  # 清空上一步残余更新参数值
        loss.backward() # 误差反向传播，计算参数更新值
        opt.step() # 将参数更新值施加到net的parmeters上

        bar.set_description("Train epoch %d, loss %.4f" % (
            epoch, loss.item()
        ))
    torch.save(model,r'model\chinese_new.pt')
    torch.save(model.state_dict(), f'model\chinese_new_state_dict.pth')

#


